/*	1993,1994,1995,1998	H.Ogasawara (COR.)	*/
/*	1998				S.Honma (Rick)		*/

#include	<stdio.h>
#include	<string.h>
#include	<isalib.h>
#include	"maish.h"

#define		ENCODING	"Base64"


char	file_outname[STRBUF],			/* o̓t@C */
		base[94],						/* WJfBNg */
		exfile[STRBUF];					/* owt@C */
static unsigned char	ibuf[IOBUF];	/* ͍sobt@ */

static int	attach_check( unsigned char* );
static int	text_decode( FILE*, char* );
static void	bin_decode( FILE* );
static int	content_decode( FILE* );
static int	uucheck( FILE*, char* );
static void	MimeDec( FILE* );


static int
attach_check( ptr )
unsigned char	*ptr;
{
	unsigned char	buf[IOBUF], *tmp;
	tmp= get_word( buf, ptr );
/*	if( !p_strmatch( buf, "attachment" ) ){*/
		if( *tmp == ';' )
			ptr= get_word( buf, tmp + 1 );
		if( !p_strcmpi( buf, "filename" ) ){
			if( *ptr == '=' ){
				get_tkn( file_outname, ptr+1 );
				return TRUE;
			}
		}
/*	}*/
	return FALSE;
}

static int
text_decode( fp, boundary )
FILE	*fp;
char	*boundary;
{
	char	fullname[STRBUF], *ptr;
	int	ret= FALSE;
	FILE	*fo;
	int	nextline= 0;

	if( !*file_outname )	return FALSE;
	ptr= p_strcpy( fullname, base );
	p_strcpy( ptr, file_outname );
	fputs( file_outname, stderr );
	fputc( ' ', stderr );

	if( fo= fopen( fullname, "wt" ) ){
		while( fgets( ibuf, IOBUF, fp ) ){
			if( !p_strmatch( ibuf, boundary ) ){
				ret= TRUE;
				break;
			}
			if( !nextline-- ){
				fputc( 'o', stderr );		/* i\ */
				nextline= 100;
			}
			fputs( ibuf, fo );
		}
		fclose( fo );
		fputc( '\n', stderr );
	}else {
		fputs( " open error\n", stderr );
	}
	return ret;
}

static void
bin_decode( fp )
FILE	*fp;
{
	unsigned char	obuf[IOBUF];
	unsigned char	fullname[STRBUF], *ptr;
	FILE	*fo;
	int	nextline= 0;

	if( !*file_outname )	return;
	ptr= p_strcpy( fullname, base );
	p_strcpy( ptr, file_outname );
	fputs( file_outname, stderr );
	fputc( ' ', stderr );

	if( fo= fopen( fullname, "wb" ) ){
		for(; fgets( ibuf, IOBUF, fp ) ;){
			if( *ibuf == '\n' )	break;
			ptr= decbenc( obuf, ibuf );
			fwrite( obuf, sizeof( char ), ptr - obuf, fo );
			if( !nextline-- ){
				fputc( 'o', stderr );		/* i\ */
				nextline= 100;
			}
		}
		fclose( fo );
		fputc( '\n', stderr );
	}else {
		fputs( " open error\n", stderr );
	}
}

static int
content_decode( fp )
FILE	*fp;
{
	char	encoding_name[60];
	int	ret= 0;

	*encoding_name= '\0';
	*file_outname= '\0';

	while( fgets822( ibuf, IOBUF, fp ) ){
		if( !p_strmatch( ibuf, "Content-Transfer-Encoding:" ) ){
			get_word( encoding_name, ibuf+26 );
			if( !p_strcmpi( encoding_name, ENCODING ) ){
				ret+= 2;
			}else if( !p_strcmpi( encoding_name, "quoted-printable" ) ){
				ret+= 4;
			}
		}else if( !p_strmatch( ibuf, "Content-Disposition:" ) ){
			if( attach_check( ibuf+20 ) ){
				ret+= 1;
			}
		}
	}
	return ret;
}

static int
uucheck( fp, boundary )
FILE	*fp;
char	*boundary;
{
	int	q= 0;

	while( q || fgets( ibuf, IOBUF, fp ) ){
		q= 0;
		if( !p_strmatch( ibuf, boundary ) ){
			q= 1;
			break;
		}
		if( !p_strmatch( ibuf, "begin " ) ){
			if( !uu_readhead( file_outname, ibuf ) )	continue;
			if( !*exfile || !p_strcmpi( file_outname, exfile ) ){
				q= uu_decode( fp, ibuf );
			}
		}else if( !p_strmatch( ibuf,
					"(This file must be converted with BinHex 4.0)\n" ) ){
			q= ai_binhex( fp, ibuf );
		}
	}
	return q;
}

static void
MimeDec( fp )
FILE	*fp;
{
	char	file_boundary[STRBUF]= "--";
	int	BoundaryFlag= 0, q= 0;

	/* wb_΂B̉ߒBOUNDARYE */
	while( fgets822( ibuf, IOBUF, fp ) ){
		if( !p_strmatch( ibuf, "Content-Type:" ) ){
			char	*tmp;
			if( tmp= strstr( ibuf + 14, "boundary=" ) ){	/* boundary o */
				tmp+= 9;
				if( *tmp == '\"' ){	/* p̒擾 */
					char	*ptr= file_boundary + 2;
					for( ++tmp; *tmp && *tmp != '\"'; *ptr++= *tmp++ );
					*ptr= '\0';
				}else {
					p_strcpy( file_boundary + 2, tmp );
				}
				BoundaryFlag= 1;
			}
			break;
		}
	}

	if( !BoundaryFlag ){
		uucheck( fp, file_boundary );
		return;
	}

	q= 0;
	while( q || fgets( ibuf, IOBUF, fp ) ){
		q= 0;
		if( !p_strmatch( ibuf, file_boundary ) ){
			BoundaryFlag= content_decode( fp );
			if( !*exfile || !p_strcmpi( file_outname, exfile ) ){
				switch( BoundaryFlag ){
				case 5:
					q= qp_decode( fp, ibuf, file_boundary );
					continue;
				case 3:
					bin_decode( fp );
					continue;
				case 1:
					q= text_decode( fp, file_boundary );
					continue;
				}
			}
			q= uucheck( fp, file_boundary );
		}
	}

	return;
}


void
main( argc, argv )
int	argc;
unsigned char	**argv;
{
	FILE	*fp;

	base[0]= '\0';
	exfile[0]= '\0';

	while( --argc ){
		if( **++argv == '-' ){
			if( (*argv)[1] == 'b' ){		/* WJfBNgw */
				char	*ptr,
						*wptr= base;
				for( ptr= *argv + 2; *ptr; ptr++ ){
					if( *ptr == '/' ){		/* '/'  '\' ɒu */
						*wptr++= '\\';
					}else {
						*wptr++= *ptr;
					}
				}
				*wptr++= '\\';				/* I[ '\' t */
				*wptr= '\0';
			}else if( (*argv)[1] == 'x' ){	/* ot@Cw */
				p_strcpy( exfile, *argv + 2 );
			}
		}else {
			if( fp= fopen( *argv, "rt" ) ){
				MimeDec( fp );
				fclose( fp );
			}else {
				fputs( *argv, stderr );
				fputs( " open error\n", stderr );
			}
		}
	}
}
